{ Algorithm: Equation: Regula Falsi Method }

program regulaFalsiMethod(output);
var z : real;

function solve(function f(r : real) : real; low,high : real) : real;
const prec = 1e-10;
var sign,xmid,xlow,xhigh,mid : real;
	count : integer;
begin
	xlow := f(low);
	xhigh := f(high);
	sign := xlow;
	count := 0;
	repeat
		mid := (high * xlow - low * xhigh) / (xlow - xhigh);
		xmid := f(mid);
		if 0 < sign * xmid then begin
			low := mid;
			xlow := xmid;
		end else begin
			high := mid;
			xhigh := xmid;
		end;
		count := count + 1;
		writeLn('[', count, '] f(', mid::16, ') = ', xmid::16);
	until abs(xmid) < prec;
	solve := mid;
end;

procedure print(function f(r : real) : real; x : real);
begin
	writeLn('f(',x::16, ') = ', f(x)::16);
end;

function fn(x : real) : real;
begin
	fn := cos(x) - x;
end;

{ Main }
begin
	z := solve(fn,-1.0,1.0);
	print(fn,z);
end.