{ Algorithm: Equation: Muller's Method }

program methodOfMuller(output);
var z : real;

function solve(function f(r : real) : real; low,high : real) : real;
const minrep = 3;
var x0,x1,x2,x,y0,y1,y2,y,mu,lamda,delta,g,h,r,s,sq : real;
	count : integer;
begin
	x0 := high;
	x1 := (low+high)/2;
	x2 := low;
	y0 := f(x0);
	y1 := f(x1);
	y2 := f(x2);
	mu := 1.0;
	h := (high-low)/2;
	
	count := 0;
	repeat
		lamda := mu;
		delta := 1 + lamda;
		g := y2 * lamda * lamda - y1 * delta * delta + (lamda + delta) * y0;
		r := lamda * y2 - delta * y1 + y0;
		s := g * g - 4 * y0 * delta * lamda * r;
		if 0 < s then begin
			sq := sqrt(s);
			if 0 > g then sq := -sq;
			mu := -2 * y0 * delta / (g + sq);
		end else begin
			mu := -0.5 * g / lamda / r;
		end;
		h := mu * h;
		x := x0 + h;
		y := f(x);
		x2 := x1;
		y2 := y1;
		x1 := x0;
		y1 := y0;
		x0 := x;
		y0 := y;
		count := count + 1;
		writeLn('[', count, '] f(', x::16, ') = ', y::16);
	until (count >= minrep) and (abs(x0) >= abs(x1));
	solve := x;
end;

procedure print(function f(r : real) : real; x : real);
begin
	writeLn('f(',x::16, ') = ', f(x)::16);
end;

function fn(x : real) : real;
begin
	fn := cos(x) - x;
end;

{ Main }
begin
	z := solve(fn,-1.0,1.0);
	print(fn,z);
end.