{ Algorithm: Equation: Steffensen's Method }

program methodOfSteffensen(output);
var z : real;

function solve(function f(r : real) : real; low,high : real) : real;
const minrep = 5;
var x0,y0,x, y,denom : real;
	count : integer;
	b : Boolean;
begin
	b := f((low+high)/2) > (f(low) + f(high))/2;
	if f(high) < f(low) then b := not b;
	if b then begin
		x := low;
		y := f(low);
	end else begin
		x := high;
		y := f(high);
	end;
	denom := f(x+y) - y;
	
	repeat
		x0 := x;
		y0 := y;
		x := x0 - y0 * y0 / denom;
		y := f(x);
		denom := f(x+y) - y;	
		count := count + 1;
		writeLn('[', count, '] f(', x::16, ') = ', y::16);
	until (0.0 = denom) or ((count >= minrep) and (abs(y) >= abs(y0)));
	solve := x;
end;

procedure print(function f(r : real) : real; x : real);
begin
	writeLn('f(',x::16, ') = ', f(x)::16);
end;

function fn(x : real) : real;
begin
	fn := cos(x) - x;
end;

{ Main }
begin
	z := solve(fn,-1.0,1.0);
	print(fn,z);
end.