{ Algorithm: Equation: Discrete Newton's Method }

program discreteNewtonsMethod(output);
var z : real;
function solve(function f(r : real) : real; low,high : real) : real;
const n = 1000;
var x, y,xi,yi,oldy,delta,df : real;
	count : integer;
	b : Boolean;
begin
	b := f((low+high)/2) > (f(low) + f(high))/2;
	if f(high) < f(low) then b := not b;
	if b then begin
		x := low;
		y := f(low);
		xi := high;
		yi := f(high);
	end else begin
		x := high;
		y := f(high);
		xi := low;
		yi := f(low);
	end;
	
	repeat
		oldy := y;
		delta := (x - xi) / n;
		df := delta / (f(x+delta) - f(x));
		x := x - y * df;
		y := f(x);
		xi := xi - yi * df;
		yi := f(xi);
		count := count + 1;
		writeLn('[', count, '] f(', x::16, ') = ', y::16);
	until abs(y) >= abs(oldy);
	solve := x;
end;

procedure print(function f(r : real) : real; x : real);
begin
	writeLn('f(',x::16, ') = ', f(x)::16);
end;

function fn(x : real) : real;
begin
	fn := cos(x) - x;
end;

{ Main }
begin
	z := solve(fn,-1.0,1.0);
	print(fn,z);
end.