{ Algorithm: Linear Equation: Simple Gauss Elimination }

program simpleGaussElimination(output);
const n = 4;
	m = 3;
type vector = array[1..n] of real;
	matrix = array[1..n] of vector;
	vectors = array[1..m] of vector;
var aa : matrix;
	xx, bb : vectors;
	i,j,l : integer;

procedure solve(a : matrix; var x : vectors;  b : vectors);
var i,j,k,l : integer;
	pivot, r : real;
begin
	for k := 1 to n-1 do begin
		pivot := a[k][k];
		for j := k+1 to n do a[k][j] := a[k][j] / pivot;
		for j := 1 to m do b[j][k] := b[j][k] / pivot;
		for i := k+1 to n do begin
			r := a[i][k];
			for j := k+1 to n do a[i][j] := a[i][j] - a[k][j] * r;
			for l := 1 to m do b[l][i] := b[l][i] - b[l][k] * r;
		end;
	end;
	pivot := a[n][n];
	for l := 1 to m do x[l][n] := b[l][n] / pivot;
	for k := n-1 downto 1 do begin
		for l := 1 to m do begin
			r := b[l][k];
			for j := k+1 to n do r := r - a[k][j] * x[l][j];
			x[l][k] := r;
		end;
	end;
end;

procedure printEquation(var a : matrix; var x,b : vectors);
var i,j,l : integer;
begin
	for i := 1 to n do begin
		write('{');
		for j := 1 to n do write(a[i][j]:6:1, ' ');
		write('}{');
		for l := 1 to m do write(x[l][i]:6:1, ' ');
		if i = n div 2 then write('} = {') else write('}   {');
		for l := 1 to m do write(b[l][i]:6:1, ' ');
		writeLn('}');
	end;
end;

function getA(i,j : integer) : real;
begin
	getA := round(random * 10);
end;

function getB(l,i : integer) : real;
begin
	getB := round(random * 10);
end;

{ Main }
begin
	for i := 1 to n do for j := 1 to n do aa[i][j] := getA(i,j);
	for l := 1 to m do for i := 1 to n do bb[l][i] := getB(l,i);
	solve(aa,xx,bb);
	printEquation(aa,xx,bb);
end.