{ Algorithm: Pattern Matching: KMP Matching }
program KMPMatching(input,output,script);
const maxlen = 20;
	maxline = 1024;
type word = packed array[0..maxlen] of char;
	line = packed array[0..maxline] of char;
	key = record
		vec : word;
		start : array[0..maxlen] of integer;
	end;
var script : text;
	w : word;
	k : key;

{ Knuth-Morris-Pratt Matching Algorithm }
procedure initKey(var ky : key; var wd : word);
var i,j : integer;
	b : Boolean;
function sequenceEqual(var wrd :word; m, n, len : integer) : Boolean;
var bb : Boolean;
begin
	bb := true;
	while bb and (0 < len) do begin
		if wrd[m] <> wrd[n] then bb := false;
		len := len -1;
		m := m + 1;
		n := n + 1;
	end;
	sequenceEqual := bb;
end;

begin
	b := true;
	ky.start[0] := 0;
	for i := 1 to maxlen do begin
		ky.start[i] := 0;
		if b then begin
			j := 1;
			while j < i do begin
				if sequenceEqual(wd, j, 0, i - j) then begin
					ky.start[i] := i - j;
					j := i;
				end else begin
					j := j + 1;
				end;
			end;
			if chr(0) = wd[i] then b := false;
		end;
	end;
	ky.vec := wd;
end;

function match(var ky : key; var buf : line; start : integer) : integer;
var i, j, k, len : integer;
	cont : Boolean;
begin
	buf[maxline] := chr(0);
	ky.vec[maxlen] := chr(0);
	
	cont := true;
	i := 0;
	j := start;
	k := -1;

	if (chr(0) = ky.vec[0]) or (maxline <= start) then cont := false;
	while cont do begin
		if chr(0) = ky.vec[i] then begin
			k := j - i;
			cont := false;
		end else if chr(0) = buf[j] then begin
			cont := false;
		end else if ky.vec[i] = buf[j] then begin
			i := i + 1;
			j := j + 1;
		end else if 0 = i then begin
			 j := j + 1;
		end else begin
			i := ky.start[i];
		end;
	end;
	match := k;
end;

{ Read Text }
procedure matchText(var ky : key);
var buf : line;
	i,m,n,rows,count : integer;
begin
	reset(script);
	count := 0;
	rows := 0;
	while not eof(script) do begin
		readLn(script, buf);
		rows := rows + 1;
		m := 1;
		n := match(ky, buf, 0);
		if 0 <= n then begin
			writeLn('Found in line ', rows, ' (hit return to continue):');
			writeLn(buf);
			repeat
				count := count + 1;
				for i := m to n do write(' ');
				write('^');
				m := n + 2;
				n := match(ky, buf, n + 1);
			until 0 > n;
			writeLn;
			readLn;
		end;
	end;
	writeLn('Total ', count, ' times found');
end;

{ Main Routine }
begin
	write('Pattern: ');
	readLn(w);
	initKey(k, w);
	matchText(k);
end.
