{ Algorithm: Search: Linear Search }

program linearSearch(output, data);
const maxlen = 20;
	maxline = 1024;
type word = packed array[0..maxlen] of char;
	line = packed array[0..maxline] of char;
	pcell = ^cell;
	cell = record
		next : pcell;
		value : word;
	end;
	
var data : text;
	header : pcell;
	w : word;
	tolower : array['A'..'Z'] of char;
	c1, c2 : char;

{ Linear Search Algorithm }
function addHead(list : pcell; var value : word) : pcell;
var cellNew : pcell;
begin
	new(cellNew);
	cellNew^.next := list;
	cellNew^.value := value;
	addHead := cellNew;
end;

function search(list : pcell; var value : word) : Boolean;
begin
	while (nil <> list) and (list^.value <> value) do list := list^.next;
	search := (nil <> list);
end;

function insert(list : pcell; var value : word) : pcell;
begin
	if not search(list, value) then list := addHead(list, value);
	insert := list;
end;

procedure print(list : pcell);
begin
	while nil <> list do begin
		writeLn(list^.value);
		list := list^.next;
	end;
end;

{ Text Parsing }
function parseLine(list : pcell; var buf : line) : pcell;
label 100;
var i, j, k, len : integer;
	value : word;
	ch : char;
begin
	len := 0;
	for i := 0 to maxline do begin
		ch := buf[i];
		if ('A' <= ch) and ('Z' >= ch) then ch := tolower[ch];
		if ('a' <= ch) and ('z' >= ch) then begin
			if len < maxlen then begin
				value[len] := ch;
				len := len + 1;
			end;
		end else begin
			if 2 < len then begin
				for k := len to maxlen do value[k] := chr(0);
				list := insert(list, value);
			end;
			len := 0;
			if chr(0) = ch then goto 100;
		end;
	end;
100:
	parseLine := list;
end;

function parseText(list : pcell) : pcell;
var buf : line;
begin
	reset(data);
	while not eof(data) do begin
		readLn(data, buf);
		writeLn(buf);
		list := parseLine(list, buf);
	end;
	parseText := list;
end;

{ Main Routine }
begin
	c2 := 'a';
	for c1 := 'A' to 'Z' do begin
		tolower[c1] := c2;
		c2 := succ(c2);
	end;
	
	writeLn('Input Text:');
	header := parseText(header);

	writeLn('Contained Words:');
	print(header);
end.
