{ Algorithm: Search: Hash Table }

#stack 10000

program hashTableSearch(output,data);
const maxlen = 20;
	maxline = 1024;
	hashsize = 1000;
type word = packed array[0..maxlen] of char;
	line = packed array[0..maxline] of char;
	cellState = (empty, occupied, deleted);
	cell = record
		state : cellState;
		value : word;
	end;
	table = array[1..hashsize] of cell;
	
var data : text;
	header : table;
	w : word;
	tolower : array['A'..'Z'] of char;
	rehasher : array[1..hashsize] of integer;
	c1, c2 : char;

{ Hash Table Algorithm }
procedure init(var tab : table);
var i, j, n : integer;
begin
	for i := 1 to hashsize do begin
		tab[i].state := empty;
		rehasher[i] := i - 1;
	end;
	for i := 1 to hashsize-1 do begin
		j := i + trunc(random * (hashsize - i));
		n := rehasher[j];
		rehasher[j] := rehasher[i];
		rehasher[i] := n;
	end;
end;

function hash(var value : word) : integer;
var i, key, mul : integer;
begin
	i := 0;
	mul := 7;
	key := 0;
	while i <= maxlen do begin
		if chr(0) = value[i] then
			i := maxlen + 1
		else begin
			key := key + (ord(value[i]) - ord('a')) * mul;
			i := i + 1;
			mul := (mul * mul) mod hashsize;
		end;
	end;
	hash := (key mod hashsize) + 1;
end;

function rehash(key : integer) : integer;
begin
	rehash := ((key + rehasher[key]) mod hashsize) + 1
end;

procedure insert(var tab : table; var value : word);
var key : integer;
	count : integer;
begin
	count := 0;
	key := hash(value);
	while (occupied = tab[key].state)
		and (value <> tab[key].value) 
		and (hashsize > count) do begin
		count := count + 1;
		key := rehash(key);
	end;
	if hashsize > count then begin
		if occupied <> tab[key].state then begin
			tab[key].state := occupied;
			tab[key].value := value;
		end;
	end else begin
		writeLn('The hash table is full');
	end;
end;

procedure print(var tab : table);
var i : integer;
begin
	for i := 1 to hashsize do begin
		if occupied = tab[i].state then writeLn(tab[i].value);
	end;
end;

{ Text Parsing }
procedure parseLine(var tab : table; var buf : line);
label 100;
var i, j, k, len : integer;
	value : word;
	ch : char;
begin
	len := 0;
	for i := 0 to maxline do begin
		ch := buf[i];
		if ('A' <= ch) and ('Z' >= ch) then ch := tolower[ch];
		if ('a' <= ch) and ('z' >= ch) then begin
			if len < maxlen then begin
				value[len] := ch;
				len := len + 1;
			end;
		end else begin
			if 2 < len then begin
				for k := len to maxlen do value[k] := chr(0);
				insert(tab, value);
			end;
			len := 0;
			if chr(0) = ch then goto 100;
		end;
	end;
100:
end;

procedure parseText(var tab : table);
var buf : line;
begin
	reset(data);
	while not eof(data) do begin
		readLn(data, buf);
		writeLn(buf);
		parseLine(tab, buf);
	end;
end;

{ Main Routine }
begin
	c2 := 'a';
	for c1 := 'A' to 'Z' do begin
		tolower[c1] := c2;
		c2 := succ(c2);
	end;
	
	init(header);
	
	writeLn('Input Text:');
	parseText(header);

	writeLn('Contained Words:');
	print(header);
end.
