{ Algorithm: Sort: Modified Quick Sort }
program modifiedQuickSort(output);
const n = 100;
	m = 7;	{ 2**m > n }
	limit = 10;
type table = array[1..n] of integer;
var a : table;

{ Modified Quick Sort Algorithm }
procedure insertionSort(var t : table; min, max : integer);
var i,j,w : integer;
	br : Boolean;
begin
	for i := min+1 to max do begin
		w := t[i];
		j := i;
		br := false;
		repeat
			if t[j-1] > w then begin
				t[j] := t[j-1];
				j := j - 1;
			end else begin
				br := true;
			end;
		until (1 = j) or br;
		t[j] := w;
	end;
end;

procedure sort(var t : table);
type stack = array[1..m] of integer;
var i,j,k,pivot,w,min,max,sp : integer;
	mins,maxs : stack;
begin
	sp := 1;
	mins[1] := 1;
	maxs[1] := n;
	while 0 < sp do begin
		min := mins[sp];
		max := maxs[sp];
		sp := sp - 1;
		{ note: We sort all sequences shorter than limt by insertion-sort. }
		if min + limit < max then begin
			{ note: pivot is the median of min, max and the center }
			i := (min + max) div 2;
			w := t[i];
			if t[min] < t[max] then begin
				if w < t[min] then
					k := min
				else if t[max] < w then
					k := max
				else
					k := i;
			end else begin
				if w < t[max] then
					k := max
				else if t[min] < w then
					k := min
				else
					k := i;
			end;
			if k <> max then begin
				w := t[max];
				t[max] := t[k];
				t[k] := w;
			end;
			
			pivot := t[max];
			i := min;
			j := max - 1;
			while t[i] < pivot do i := i + 1;
			while (i < j) and (t[j] > pivot) do j := j - 1;
			while i < j do begin
				w := t[i];
				t[i] := t[j];
				t[j] := w;
				while t[i] < pivot do i := i + 1;
				while (i < j) and (t[j] > pivot) do j := j - 1;
				while (i < j) and (t[i] = pivot) and (t[j] = pivot) do begin
					i := i + 1;
					j := j - 1;
				end;
			end;
			w := t[i];
			t[i] := pivot;
			t[max] := w;
			{ note: We sort  the shorter sequence before the other. }
			if i - min < max - i then begin
				if i + 1 < max then begin
					sp := sp + 1;
					mins[sp] := i + 1;
					maxs[sp] := max;
				end;
				if min < i - 1 then begin
					sp := sp + 1;
					mins[sp] := min;
					maxs[sp] := i - 1;
				end;
			end else begin
				if min < i - 1 then begin
					sp := sp + 1;
					mins[sp] := min;
					maxs[sp] := i - 1;
				end;
				if i + 1 < max then begin
					sp := sp + 1;
					mins[sp] := i + 1;
					maxs[sp] := max;
				end;
			end;
		end else if min < max then begin
			insertionSort(t,min,max);
		end;
	end;
end;

{ Create Input Data }
procedure init(var t : table);
var i : integer;
begin
	for i := 1 to n do t[i] := trunc(random * 1000);
end;

{ Print Data }
procedure print(var t : table);
var i : integer;
begin
	for i:= 1 to n do begin
		write(t[i]:4);
		if 0 = i mod 10 then writeLn;
	end;
end;

{ Main }
begin
	init(a);
	writeLn('Input Data:');
	print(a);
	writeLn;
	sort(a);
	writeLn('Sorted Data:');
	print(a);
end.
