{ Algorithm: Sort: Merge Sort }
program mergeSort(output);
const n = 100;
type table = array[1..n] of integer;
var a, work : table;

{ Merge Sort Algorithm }
procedure sortRec(var t : table; min, max : integer);
var i,j,k,mid : integer;
begin
	if min < max then begin
		{------- divide into 2 sequences -------}
		mid := (min + max) div 2;
		sortRec(t,min,mid);
		sortRec(t,mid+1,max);
		{------- copy the left -------}
		for i := min to mid do work[i] := t[i];
		{------- copy the right reversely -------}
		j := max;
		for i := mid+1 to max do begin
			work[i] := t[j];
			j := j - 1;
		end;
		{------- merge -------}
		i := min;
		j := max;
		for k := min to max do begin
			if work[i] <= work[j] then begin
				a[k] := work[i];
				i := i + 1;
			end else begin
				a[k] := work[j];
				j := j - 1;
			end;
		end;
	end;
end;

procedure sort(var t : table);
begin
	sortRec(t, 1, n);
end;

{ Create Input Data }
procedure init(var t : table);
var i : integer;
begin
	for i := 1 to n do t[i] := trunc(random * 1000);
end;

{ Print Data }
procedure print(var t : table);
var i : integer;
begin
	for i:= 1 to n do begin
		write(t[i]:4);
		if 0 = i mod 10 then writeLn;
	end;
end;

{ Main }
begin
	init(a);
	writeLn('Input Data:');
	print(a);
	writeLn;
	sort(a);
	writeLn('Sorted Data:');
	print(a);
end.
