{ ؕ }
#heap 25000

program kipp(input,output);
label 100;
const MAXNUM = 5;
   MAXNODE   = MAXNUM + MAXNUM;
type data    = integer;
   chunkp    = ^chunk;
   chunk     = record
		  value	     : data;
		  prev, next : chunkp
	       end;
   nodekind  = (op, va);
   nodeindex = 1..MAXNODE;
   node	     = record
		  case nk : nodekind of
		    op : (o1, o2 : char; left, right : nodeindex);
		    va : (v : data)
	       end;
   anode     = array[1..MAXNODE] of node;
   withindex = record
		  value	: data;
		  index	: nodeindex
	       end;
   adata     = array[1..MAXNUM] of data;
   aindex    = array[1..MAXNODE] of withindex;
var n			: integer;
   an			: adata;
   ai			: aindex;
   expr			: anode;
   i			: integer;
   primitive		: chunkp;
   terminator		: chunkp;
   count		: integer;

procedure ASSERT(b : boolean);
begin
   if not b then begin
      writeln;
      writeln('An error caused termination!');
      goto 100
   end
end; { ASSERT }

procedure printNode(si : nodeindex);
begin
   if expr[si].nk = va then
      write(expr[si].v:1)
   else begin
      ASSERT(expr[si].nk = op);
      write('(');
      if expr[si].o1 <> ' ' then write(expr[si].o1);
      printNode(expr[si].left);
      write(expr[si].o2);
      printNode(expr[si].right);
      write(')')
   end
end; { printNode }

procedure addChunk(v : integer );
label 10, 20;
var cp,dp : chunkp;
procedure hinsert(inc,posc : chunkp);
var scp	: chunkp;
begin
   scp := posc^.next;
   scp^.prev := inc;
   inc^.next := scp;
   posc^.next := inc;
   inc^.prev := posc
end; { hinsert }
   
begin
   
   if primitive = nil then begin
      new(primitive);
      new(terminator);
      primitive^.prev := terminator;
      primitive^.next := terminator;
      terminator^.prev := primitive;
      terminator^.next := primitive;
      primitive^.value := v;
      terminator^.value := 0;
      goto 20
   end;
   
   dp := primitive;
   10:
   if dp^.value = v then goto 20;
   if dp^.value > v then
      if (dp^.prev = terminator) or (dp^.prev^.value < v) then begin
	 new(cp);
	 cp^.value := v;
	 hinsert(cp, dp^.prev)
      end else begin
	 dp := dp^.prev;
	 goto 10
      end
   else
      if (dp^.next = terminator) or (dp^.next^.value > v) then begin
	 new(cp);
	 cp^.value := v;
	 hinsert(cp, dp)
      end else begin
	 dp := dp^.next;
	 goto 10
      end;
   20:
end; { addChunk }

procedure initNode;
var si : integer;
begin
   for si := 1 to n do begin
      expr[si].nk := va;
      expr[si].v := an[si];
      ai[si].value := an[si];
      ai[si].index := si
   end;
   for si := (n+1) to (n*2) do expr[si].nk := op
end;

procedure analyze(len: integer);
var pre, post : integer;
    str, str2	: withindex;
begin
   if len = 1 then begin
      addChunk(ai[1].value);
      printNode(ai[1].index);
      writeln('=',ai[1].value:4);
      count := count + 1
   end else begin
      ASSERT(len > 1);
      for pre := 1 to (len - 1) do
	 for post := (pre + 1) to len do begin
	    str.value := ai[pre].value;
	    str.index := ai[pre].index;
	    str2.value := ai[post].value;
	    str2.index := ai[post].index;
	    ai[post].value := ai[len].value;
	    ai[post].index := ai[len].index;
	    ai[pre].value := str.value + str2.value;
	    ai[pre].index := n+len;
	    expr[n+len].left := str.index;
	    expr[n+len].right := str2.index;
	    expr[n+len].o1 := ' ';
	    expr[n+len].o2 := '+';
	    analyze(len-1);
	    ai[pre].value := str.value - str2.value;
	    expr[n+len].o2 := '-';
	    analyze(len-1);
	    ai[pre].value := - str2.value - str.value;
	    expr[n+len].o1 := '-';
	    analyze(len-1);
	    ai[pre].value := str2.value - str.value;
	    expr[n+len].o2 := '+';
	    analyze(len-1);
	    ai[pre].value := - str2.value * str.value;
	    expr[n+len].o2 := '*';
	    analyze(len-1);
	    ai[pre].value := str2.value * str.value;
	    expr[n+len].o1 := ' ';
	    analyze(len-1);

	    ai[pre].value := str.value;
	    ai[pre].index := str.index;
	    ai[post].value := str2.value;
	    ai[post].index := str2.index
      	 end;
   end;
end; { analyze }

procedure printChunk;
label 100;
var minc : chunkp;
begin
   if primitive = nil then goto 100;
   minc := primitive;
   while terminator <> minc^.prev do
      minc := minc^.prev;
   repeat
      write(minc^.value, '<');
      minc := minc^.next
   until minc = terminator;
   100:
end; { printChunk }

begin
   primitive := nil;
   count := 0;
   write('number of numbers:');
   readln(n);
   ASSERT(n <= MAXNUM);
   writeln('values:');
   for i := 1 to n do readln(an[i]);
   initNode;
   analyze(n);
   writeln;
   writeln('total', count:5, ' patterns were tried!');
   printChunk;
   100:writeln
end.