{ Graphics }
#option 'gso'
{
	note: Option 'g' links the first external file to a graphic stream.
}

program graphics(g);
const pitch = 60;
	theta = 8;
	module = 20;
	width = 200;
	radius = 7 * pitch / 3.1416;
	prec = 50;
	delta = 3.1416 * 2 / prec;
	add = radius * delta;
var i, nx: integer;
	rx, ry, p, q, r, si, co, al : real;
	forecolor : integer;
	g : text;

procedure gInit(left,top,right,bottom : integer);
begin
	rewrite(g);
	writeLn(g, 'WINDOW ', abs(right - left), ',', abs(bottom - top));
	writeLn(g, 'VIEW (', left, ',', top, ')-(', right, ',', bottom, ')');
	forecolor := 0;
end;

procedure moveTo(x,y:integer);
begin
	writeLn(g, 'MOVE (', x, ',', y, ')');
end;

procedure lineTo(x,y:integer);
begin
	writeLn(g, 'LINE -(', x, ',', y, '),', forecolor);
end;

function rack(x : integer) : integer;
const p1 = theta;
	p2 = pitch div 2 - theta;
	p3 = pitch div 2;
	p4 = pitch div 2 + theta;
	p5 = pitch - theta;
var p : integer;
begin
	x := (x + pitch * 100) mod pitch;
	if x < p1 then
		rack := (x * module) div theta
	else if x < p2 then
		rack := module
	else if x < p4 then
		rack := ((p3 - x) * module) div theta
	else if x < p5 then
		rack := -module
	else
		rack := ((x - pitch) * module) div theta;
end;

{ Main }
begin
	gInit(-width, -width, width, width);
	al := -3.1416;
	p := 0;
	for i := 1 to prec do begin
		co := cos(al);
		si := sin(al);

		ry := radius + Rack(-width);
		q := co * (-width) + si * ry;
		r := -si * (-width) + co * ry;
		moveTo(trunc(q), trunc(r));
	
		for nx := -width to width do begin
			rx := nx;
			ry := radius + rack(nx+trunc(p));
			q := co * rx + si * ry;
			r := -si * rx + co * ry;
			lineTo(trunc(q), trunc(r));
		end;
		al := al + delta;
		p := p + add;
	end;
	writeLn(g, 'PAINT (0, 0), 12');
end.

