{ Method Test }
class Space;
const
	Dimension = 3;
type
	Value = real;
.

class Vector;
var
	x : array[1..Space.Dimension] of Space.Value;
function Product(a, b : Vector) : Space.Value;
var
	i : integer;
	v : Space.Value;
begin
	v := Space.Value(0);
	for i := 1 to Space.Dimension do v := v + a.x[i] * b.x[i];
	Product := v;
end;
function ToString(var a : Vector) : string;
var
	i : integer;
	s : string;
begin
	s := '(';
	for i := 1 to Space.Dimension do s := s & a.x[i] & ' ';
	ToString := s & ')';
end;
.

class Matrix;
var
	u : array[1..Space.Dimension] of Vector;
	name : string;
function Product(var a, b : Matrix) : Matrix;
var
	i, j, k : integer;
	v : Space.Value;
	m : Matrix;
begin
	for i := 1 to Space.Dimension do begin
		for j := 1 to Space.Dimension do begin
			v := Space.Value(0);
			for k := 1 to Space.Dimension do begin
				v := v + a.u[i].x[k] * b.u[k].x[j];
			end;
			m.u[i].x[j] := v;
		end;
	end;
	Product := m;
end;
function ToString(a : Matrix) : string;
var
	i, j : integer;
	s : string;
begin
	s := '(';
	for i := 1 to Space.Dimension do begin
		s := s & '(';
		for j := 1 to Space.Dimension do begin
			s := s & a.u[i].x[j] & ' ';
		end;
		s := s & ')';
	end;
	ToString := s & ')';
end;
.

{ example }
program prog1(input, output);
var
	i, j : integer;
	v, u : Vector;
	m, n : Matrix;
begin
	v := Vector((1, 2, 3));
	u := Vector((4, 5, 6));
	for i := 1 to Space.Dimension do begin
		for j := 1 to Space.Dimension do begin
			m.u[i].x[j] := v.x[i] * u.x[j];
			n.u[i].x[j] := v.x[i] + u.x[j];
		end;
	end;
	writeLn(v.ToString, ' * ', u.ToString, ' = ', Vector.Product(v, u));
	writeLn(m.ToString, ' \n* ', n.ToString);
	writeLn(' = ', Matrix.Product(m, n).ToString);
end.
