(* pointers and arrays *)

program ptr_array(input, output);
const dim = 3;
type value = real;
	vector = array[1..dim] of value;
	matrix = array[1..dim,1..dim] of value;
var i, j, k : integer;
	x, y, z : vector;
	a, b, c : matrix;

procedure vec_vec_add(var left, right, result : array[lo..hi:integer] of value);
var i : integer;
	p, q, r : ^value;
begin
	q := left;
	r := right;
	for i := lo to hi do begin
		p := &result[i];
		p^ := q^ + r^;
		writeLn(p^, ' = ', q^, ' + ', r^);
		q := &q[1];
		r := &r[1];
	end;
end;

procedure mat_mat_product(var left, right, result : array[lo1..hi1:integer;lo2..hi2:integer] of value);
var i, j, k : integer;
	v : value;
begin
	if (lo1 <> lo2) or (hi1 <> hi2) then halt;
	for i := lo1 to hi1 do begin
		for j := lo1 to hi1 do begin
			v := 0;
			for k := lo1 to hi1 do v := v + left[i,k] * right[k,j];
			result[i,j] := v;
		end
	end
end;

procedure print_vec(vec : array[lo..hi:integer] of value);
var i : integer;
begin
	write('{');
	for i := lo to hi do write(vec[i]:12);
	writeln('}');
end;

procedure print_mat(mat : array[lo1..hi1:integer;lo2..hi2:integer] of value);
var i, j : integer;
begin
	for i := lo1 to hi1 do begin
		write('|');
		for j := lo2 to hi2 do write(mat[i,j]:12);
		writeln('|');
	end;
	writeln;
end;

procedure print_mat2(var mat : matrix);
var i, j : integer;
begin
	for i := 1 to dim do begin
		write('|');
		for j := 1 to dim do write(mat[i,j]:12);
		writeln('|');
	end;
	writeln;
end;

begin
	for i := 1 to dim do begin
		x[i] := i;
		y[i] := i * i;
		for j := 1 to dim do begin
			a[i,j] := i + j;
			b[i,j] := i * j;
		end
	end;

	print_mat2(a);

	vec_vec_add(x, y, z);
	print_vec(x);
	print_vec(y);
	print_vec(z);
	writeln;
	mat_mat_product(a, b, c);
	print_mat(a);
	print_mat(b);
	print_mat(c);
end.